package ejem07;

public class R2 {

	double x,y;

	R2(double x,double y) { 
		this.x=x; this.y=y; 
	}
	
	public R2 copy() { 
		return new R2(x,y); 
	}
	
	public boolean equals(R2 p) { 
		return ((x==p.x)&&(y==p.y)); 
	}

	public double norm() { 
		return Math.sqrt(x*x+y*y); 
	}
	
	public double dist(R2 r) { 
		R2 aux=copy(); aux.sub(r); 
		return aux.norm(); 
	}

	public void mul(double m) { 
		x*=m; y*=m; 
	}

	public void div(double d) { 
		x/=d; y/=d; 
	}
	
	public void add(R2 p) { 
		x+=p.x; y+=p.y; 
	}
	
	public void sub(R2 p) { 
		x-=p.x; y-=p.y; 
	}
	
	public void rotR90() { 
		double aux=x; x=y; y=-aux; 
	}
	
	public void rotL90() { 
		double aux=x; x=-y; y=aux; 
	}
	
	public void normalize() {
		double abs=norm(); 
		if (abs!=0.0) { 
			div(abs); 
		} 
	}

	public double dot(R2 r) { 
		return x*r.x+y*r.y;
	}

	public void rot(double t) { 
		R2 p=copy();
		double cost=Math.cos(t);
		double sint=Math.sin(t);
		x = p.x*cost + p.y*sint;
		y =-p.x*sint + p.y*cost;
	}

	public void rot(int g) { 
		rot((double)g*Math.PI/180.0);
	}
}

