package ejem07;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class animador extends simpanim implements ActionListener {

	Button[] b;
	Label lb;

	public void init() {
		super.init();
		setLayout(new BorderLayout());
		Panel auxp=new Panel();
		add("South",auxp);
		b=new Button[6];
		auxp.setLayout(new GridLayout(1,6));
		auxp.add(b[0]=new Button("|<<"));
		auxp.add(b[1]=new Button("<"));
		auxp.add(b[2]=new Button("stop"));
		auxp.add(b[3]=new Button("play"));
		auxp.add(b[4]=new Button(">"));
		auxp.add(b[5]=new Button(">>|"));

		for (int i=0;i<b.length;i++) {
			b[i].addActionListener(this);
		}
	}

	public void start()	{
		getImages(getParameter("BASE"),getParameter("EXT"));
		super.start();
	}

	public void getImages(String BASE,String EXT) {
		MediaTracker tr=new MediaTracker(this);
		for (int i=0;i<100;i++)	{
			String num=Integer.toString(i);
			if (num.length()<2) { 
				num="0"+num; 
			}
			Image aux=getImage(getCodeBase(),BASE+num+'.'+EXT);
			tr.addImage(aux,i);
			try { 
				tr.waitForID(i);
				if (!tr.isErrorID(i)) { 
					addImage(aux); 
				}
			} catch(InterruptedException e) { 
			}
		}
	}

	public void actionPerformed(ActionEvent e) {
		String command=e.getActionCommand().trim();
		if (command.equals("play")) { 
			continuar(); 
		} else if (command.equals("stop")) { 
			parar(); 
		} else if (command.equals("|<<")) { 
			inicio(); 
		} else if (command.equals(">>|")) { 
			fin(); 
		} else if (command.equals("<")) { 
			anterior(); 
		} else if (command.equals(">")) { 
			siguiente(); 
		} else { 
			return;
		}
		repaint();
	}

}

