package ejem07;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.net.*;

public class mueveTextos extends Applet implements Runnable {

	Color BGcolor;
	Image logo=null;
	int logox=0, logoy=0;
	int orilla;
	static final int NTF=5,NTM=3;
	/* ----- variables para textos fijos ----- */
	Font fontF;
	Color[] cF=new Color[NTF]; 
	String[] FT=new String[NTF];
	int fx[]=new int[NTF],fy[]=new int[NTF];
	/* ---- variables para textos mviles ---- */
	Font fontM;
	Color[] cM=new Color[NTM];
	String[] MT=new String[NTM];
	int[] mx=new int[NTM],my=new int[NTM];
	int[] vx={1, 2, 1}, vy={ 1, 1, 2};  
	int mstrh,mstra;
	int[] mstrw=new int[NTM];
	/* --------------------------------------- */
	Thread animator=null;
	Image imagen=null;

	public void init() { 
	// ------------ COLORES --------------------------
		BGcolor=staticLib.color(getParameter("BGCOLOR"),Color.black); 
		this.setBackground(BGcolor);
		// ------------ imagen o logotipo ----------------
		logo=getImage(getCodeBase(),getParameter("LOGO"));
		logox=staticLib.integer(getParameter("LOGOx"),logox); 
		System.out.println(getParameter("LOGOx")+","+getParameter("LOGOy"));
		logoy=staticLib.integer(getParameter("LOGOy"),logoy);
		// ------------- Orilla -----------------
		orilla=staticLib.integer(getParameter("ORILLA"),4);
		// ------------ tipos de letra -------------------
		fontF=new Font(staticLib.string  (getParameter("Ffont"),"TimesRoman"),
		staticLib.fontType(getParameter("FType"),Font.PLAIN),
		staticLib.integer (getParameter("FSize"),16));
		fontM=new Font(staticLib.string  (getParameter("Mfont"),"TimesRoman"),
		staticLib.fontType(getParameter("MType"),Font.BOLD+Font.ITALIC),
		staticLib.integer (getParameter("MSize"),12));
		// ------------ textos fijo ----------------------
		FT[0]=staticLib.string(getParameter("FW"),FT[0]); 
		FT[1]=staticLib.string(getParameter("FC"),FT[1]); 
		FT[2]=staticLib.string(getParameter("FE"),FT[2]); 
		FT[3]=staticLib.string(getParameter("FN"),FT[3]); 
		FT[4]=staticLib.string(getParameter("FS"),FT[4]); 
		// --------- colores de los textos fijos ---------
		cF[0]=staticLib.color(getParameter("FColor"),Color.white); 
		for (int n=1;n<5;n++) {
			cF[n]=cF[0]; 
		}
		cF[3]=staticLib.color(getParameter("FNColor"),cF[3]);
		cF[0]=staticLib.color(getParameter("FWColor"),cF[0]);
		cF[2]=staticLib.color(getParameter("FEColor"),cF[2]);
		cF[4]=staticLib.color(getParameter("FSColor"),cF[4]);
		// ---------- textos mviles ---------------------
		MT[0]=staticLib.string(getParameter("M1"),MT[0]); 
		MT[1]=staticLib.string(getParameter("M2"),MT[1]); 
		MT[2]=staticLib.string(getParameter("M3"),MT[2]); 
		// --------- colores de los textos mviles -------
		cM[0]=staticLib.color(getParameter("MColor"),Color.red); 
		for (int n=1;n<3;n++) {
			cM[n]=cM[0];
		}
		cM[0]=staticLib.color(getParameter("M1Color"),cM[0]);
		cM[1]=staticLib.color(getParameter("M2Color"),cM[1]);
		cM[2]=staticLib.color(getParameter("M3Color"),cM[2]);
	}

	public void start()	{
		animator=new Thread(this); 
		animator.start();
	}

	public void stop() { 
		if (animator!=null) { 
			animator.stop(); 
			animator=null; 
		}
	}

	public void paint(Graphics g) { 
		if (imagen!=null) {
			g.drawImage(imagen,0,0,this); 
		} else {
			g.setColor(Color.black); 
			g.drawString("Preparando imgenes...",21,21);
			g.setColor(Color.white); 
			g.drawString("Preparando imgenes...",20,20);
		}
	}

	public void update(Graphics g) { 
	}

	public void run() { 
		int w=getSize().width, h=getSize().height;
		Image[] fondo=fondosCirculares.crear(this,BGcolor);
		prepararVariables(w,h);
		/*----- Dibujar los textos fijos en todos los fondos ---- */
		for (int i=0;i<fondo.length;i++) {
			dibujarTextosFijos(fondo[i].getGraphics());
		}
		/* ----------------- Leer el logotipo ------------------- */
		MediaTracker tracker=new MediaTracker(this);
		if (logo!=null)	{
			tracker.addImage(logo,0);
			try { 
				tracker.waitForID(0); 
			} catch(InterruptedException e) {
			}
		}
		/* ------ Preparar la imagen auxiliar y la orilla ------- */
		imagen=this.createImage(w,h); // copia de trabajo.
		Graphics g=this.getGraphics();
		Graphics osg=imagen.getGraphics(); 
		osg.clipRect(orilla,orilla,w-2*orilla,h-2*orilla);
		int k=0;
		while (true) { 
			osg.drawImage(fondo[k],0,0,this);
			try { 
				animator.sleep(20); 
			} 
			catch (InterruptedException ie) { 
				break; 
			} 
			moverTextosMviles(w,h);
			dibujarTextosMviles(osg);
			if ((logo!=null)&&(!tracker.isErrorID(0))) { 
				//System.out.println(logox+" "+logoy);
				osg.drawImage(logo,logox,logoy,this); 
			}
			g.drawImage(imagen,0,0,this);
			k=(k+1)%fondo.length; 
		}
	}

	private void dibujarTextosFijos(Graphics g) {
		g.setFont(fontF);
		g.setColor(Color.black); // sombras
		g.drawString(FT[3],fx[3]+1,fy[3]+1);
		g.drawString(FT[0],fx[0]+1,fy[0]+1);
		g.drawString(FT[1],fx[1]+1,fy[1]+1);
		g.drawString(FT[2],fx[2]+1,fy[2]+1);
		g.drawString(FT[4],fx[4]+1,fy[4]+1);
		// textos de color
		g.setColor(cF[3]); g.drawString(FT[3],fx[3],fy[3]);
		g.setColor(cF[0]); g.drawString(FT[0],fx[0],fy[0]);
		g.setColor(cF[1]); g.drawString(FT[1],fx[1],fy[1]);
		g.setColor(cF[2]); g.drawString(FT[2],fx[2],fy[2]);
		g.setColor(cF[4]); g.drawString(FT[4],fx[4],fy[4]);
	}

	private void dibujarTextosMviles(Graphics g) {
		g.setFont(fontM);
		g.setColor(Color.black); // sombras
		for (int n=0;n<NTM;n++) {
			g.drawString(MT[n],mx[n]+1,my[n]+1); 
		}
		for (int n=0;n<NTM;n++) { // textos de color
			g.setColor(cM[n]); 
			g.drawString(MT[n],mx[n],my[n]); 
		}
	}

	private void moverTextosMviles(int w,int h) {
		for (int n=0;n<NTM;n++) { 
			mx[n]=mx[n]+vx[n]; 
			my[n]=my[n]+vy[n]; 
			if (mx[n]<=0) { 
				vx[n]= Math.abs(vx[n]); 
			}
			if (mx[n]+mstrw[n]>=w) { 
				vx[n]=-Math.abs(vx[n]); 
			}
			if (my[n]-mstra<0) { 
				vy[n]= Math.abs(vy[n]); 
			}
			if (my[n]-mstra+mstrh>=h) {
				vy[n]=-Math.abs(vy[n]); 
			}
		}
	}

	private void prepararVariables(int w,int h) {
		/* ---------- preparacin de los textos fijos ----- */
		FontMetrics fmF=getFontMetrics(fontF);
		int[] fstrw=new int[NTF];
		int fstrh=fmF.getHeight();
		int fstra=fmF.getAscent();
		for (int n=0;n<NTF;n++) {
			fstrw[n]=fmF.stringWidth(FT[n]);
		}
		int countw=fmF.stringWidth(FT[1]);
		int counth=fmF.getHeight();
		int counta=fmF.getAscent();
		fx[0]=((w-countw)/2-fstrw[0])/2;
		fy[0]=(h-fstrh)/2+fstra;
		fx[1]=(w-countw)/2; 
		fy[1]=(h-counth)/2+counta;
		fx[2]=((w-countw)/2-fstrw[2])/2+(w+countw)/2;
		fy[2]=fy[0];
		fx[3]=(w-fstrw[3])/2; 
		fy[3]=((h-fstrh)/2-fstrh)/2+fstra;
		fx[4]=(w-fstrw[4])/2; 
		fy[4]=fy[3]+(h+fstrh)/2;
		/* -------- Preparacin de los textos mviles ----------- */
		FontMetrics fmM=getFontMetrics(fontM);
		mstrh=fmM.getHeight();
		mstra=fmM.getAscent();
		for (int n=0;n<NTM;n++) {
			mstrw[n]=fmM.stringWidth(MT[n]);
		}
		/* ---- Posiciones iniciales para los textos mviles ---- */
		mx[0]=(10*w)/100; my[0]=(20*h)/100; 
		mx[1]=(30*w)/100; my[1]=(50*h)/100; 
		mx[2]=(50*w)/100; my[2]=(40*h)/100;
	}

}

