package ejem07;

import java.applet.*;
import java.awt.*;
import java.util.*;

public class simpanim extends Applet implements Runnable {

	private Thread ani=null; 
	private int n=0;
	private Vector film=new Vector();
	private long paso=200;
	private long pausa=1000;

	public void init() {
		paso=(long)Integer.parseInt(getParameter("PASO"));
		pausa=(long)Integer.parseInt(getParameter("PAUSA"));
		for (int i=0;i<100;i++) {
			String num=Integer.toString(i);
			if (num.length()<2) { 
				num="0"+num; 
			}
			String nombre=getParameter("IMA_"+num);
			if (nombre!=null) {
				addImage(getImage(getCodeBase(),nombre));
			}
		}
	}

	
	public void addImage(Image ima) { 
		film.addElement(ima); 
	}
	
	public void parar() { 
		ani.suspend(); 
	}
	
	public void continuar() { 
		ani.resume(); 
	}

	public void inicio() { 
		n=0; 
	}

	public void fin() { 
		n=film.size()-1; 
	}

	public void anterior() { 
		if (n>0) { 
			n--;
		} 
	}

	public void siguiente() { 
		if (n+1<film.size()) { 
			n++;
		} 
	}

	public void start()	{
		if (ani==null) { 
			ani=new Thread(this); 
			ani.start(); 
		}
	}

	public void stop() { 
		if (ani!=null) { 
			ani.stop(); 
			ani=null; 
		}
	}

	public void run() { 
		Graphics g=getGraphics();
		try	{
			while (true) {  
				g.drawImage((Image)film.elementAt(n),0,0,this);
				ani.sleep(paso);
				n++;
				if (n>=film.size()) { 
					ani.sleep(pausa); 
					n=0; 
				}
			}
		} catch (InterruptedException ie) { 
		} 
	}

	public void paint(Graphics g) {
		if (n<film.size()) {
			g.drawImage((Image)film.elementAt(n),0,0,this); 
		}
	}

	public void update(Graphics g) { 
		paint(g); 
	}

}

