package ejem07;

import java.awt.*;
import java.awt.event.*;

public class giraAguja extends Canvas implements Runnable, MouseListener {

	private long dT;
	private Thread thr=null;
	private Image back;
	private Graphics g,bg;
	private int w,h;
	private boolean clockwise=true;


	giraAguja(long dT) { 
		this.dT=dT; 

		addMouseListener(this);
	}

	public void start() {
		w=getSize().width;
		h=getSize().height;
		back=createImage(w,h);
		bg=back.getGraphics();
		g=getGraphics();
		if (thr==null) { 
			thr=new Thread(this); 
			thr.start(); 
		}
	}

	public void stop() {
		if (thr!=null) { 
			thr.stop(); 
			thr=null; 
		}
	}

	public void parar()  {
		if (thr!=null) { 
			thr.suspend(); 
		}
	}

	public void continuar() {
		if (thr!=null) { 
			thr.resume(); 
		}
	}

	public void run() { 
		double seg=Math.PI/30,arg=0;
		int w2=w/2,h2=h/2,R=(Math.min(w2,h2)*4)/5, r=(R*4)/5;
		while (true) {
			if (clockwise) { 
				arg+=seg; 
			} else { 
				arg-=seg; 
			}
			int x=(int)(r*Math.cos(arg));
			int y=(int)(r*Math.sin(arg));
			bg.setColor(Color.white);
			bg.fillRect(0,0,w,h);
			bg.setColor(Color.black);
			bg.fillOval(w2-R,h2-R,2*R,2*R);
			bg.setColor(Color.white);
			bg.drawLine(w2,h2,w2+x,w2+y);
			g.drawImage(back,0,0,this);
			try { 
				thr.sleep(dT); 
			} catch (InterruptedException ie) { 
				break; 
			}
		}
	}

/* --------------------- Mouse Listener ------------------ */

	public void mouseClicked(MouseEvent e) {}

	public void mousePressed(MouseEvent e) {
		clockwise=!clockwise;
	}

	public void mouseReleased(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
}