package ejem07;

import java.awt.*;

public class staticLib {

	public static String string(String str,String default_str) {
		if (str==null) { 
			return default_str; 
		} else { 
			return str; 
		}
	}

	public static int integer(String str,int default_int) {
		int aux; 
		try { 
			aux=Integer.parseInt(str); 
		} catch (NumberFormatException e) { 
			aux=default_int; 
		}
		return aux;
	}

	public static Color color(String s,Color defcol) {
		if (s==null)                         { return defcol; }
		if (s.equalsIgnoreCase("null"))      { return defcol; }
		if (s.equalsIgnoreCase("black"))     { return Color.black; }
		if (s.equalsIgnoreCase("gray"))      { return Color.gray; }
		if (s.equalsIgnoreCase("darkGray"))  { return Color.darkGray; }
		if (s.equalsIgnoreCase("lightGray")) { return Color.lightGray; }
		if (s.equalsIgnoreCase("magenta"))   { return Color.magenta; }
		if (s.equalsIgnoreCase("blue"))      { return Color.blue; }
		if (s.equalsIgnoreCase("cyan"))      { return Color.cyan; }
		if (s.equalsIgnoreCase("green"))     { return Color.green; }
		if (s.equalsIgnoreCase("yellow"))    { return Color.yellow; }
		if (s.equalsIgnoreCase("orange"))    { return Color.orange; }
		if (s.equalsIgnoreCase("red"))       { return Color.red; }
		if (s.equalsIgnoreCase("pink"))      { return Color.pink; }
		if (s.equalsIgnoreCase("white"))     { return Color.white; }
		if (s.equalsIgnoreCase("negro"))     { return Color.black; }
		if (s.equalsIgnoreCase("gris"))      { return Color.gray; }
		if (s.equalsIgnoreCase("grisOscuro")){ return Color.darkGray; }
		if (s.equalsIgnoreCase("grisClaro")) { return Color.lightGray; }
		if (s.equalsIgnoreCase("magenta"))   { return Color.magenta; }
		if (s.equalsIgnoreCase("azul"))      { return Color.blue; }
		if (s.equalsIgnoreCase("turquesa"))  { return Color.cyan; }
		if (s.equalsIgnoreCase("verde"))     { return Color.green; }
		if (s.equalsIgnoreCase("amarillo"))  { return Color.yellow; }
		if (s.equalsIgnoreCase("naranja"))   { return Color.orange; }
		if (s.equalsIgnoreCase("rojo"))      { return Color.red; }
		if (s.equalsIgnoreCase("rosa"))      { return Color.pink; }
		if (s.equalsIgnoreCase("blanco"))    { return Color.white; }
		try {
			int c=Integer.parseInt(s,16); return new Color(c);
		} catch (NumberFormatException nfe) { 
			return defcol; 
		}
	}

	public static int fontType(String str,int default_type)	{ 
		if (str!=null) {
			if (str.equalsIgnoreCase("BOLD")) { 
				return Font.BOLD; 
			} else if (str.equalsIgnoreCase("ITALIC")) { 
				return Font.ITALIC; 
			} else if ((str.equalsIgnoreCase("ITALIC+BOLD"))||
				(str.equalsIgnoreCase("BOLD+ITALIC"))) {
				return Font.BOLD+Font.ITALIC;
			}
		}
		return default_type;
	}

}